/*----------------------------------------------------------------------
	INCLUDE
----------------------------------------------------------------------*/
#include "Os.h"
#include "nces_can.h"
#include "rc_car.h"

#define	NULL				( 0 )

/* ID^Cv */
typedef uint32 TYPE_ID;

typedef struct {
	TYPE_ID		recv_id;		/* MID */
	uint8 mask;			/* }XNp^[ */
	uint8 enable;		/* bZ[Wobt@L */
	uint8 len;			/* bZ[Wf[^ */
	uint8 data[8];		/* Mf[^ */
} TYPE_RMB_INFO;

typedef struct {
	TYPE_ID		set_id;			/* ݒ肵ID */
	uint8 mask;			/* }XNp^[ */
	uint8 enable;		/* bZ[Wobt@L */
	uint8 len;			/* bZ[Wf[^ */
	uint8 data[8];		/* Mf[^ */
} TYPE_TMB_INFO;

static TYPE_RMB_INFO  g_RMB_INFO[DEF_RMB_MAX];
static TYPE_TMB_INFO  g_TMB_INFO[DEF_TMB_MAX];

STATUS
NcanInit(uint8 no)
{
	uint16 j, k;

	for( j = 0; j < DEF_RMB_MAX; j++ )
	{
		g_RMB_INFO[j].recv_id		= 0;
		g_RMB_INFO[j].mask			= 0;
		g_RMB_INFO[j].enable		= 0;
		g_RMB_INFO[j].len			= 0;
		for( k = 0; k < 8; k++ )
		{
			g_RMB_INFO[j].data[k]	= 0;
		}
	}

	for( j = 0; j < DEF_TMB_MAX; j++ )
	{
		g_TMB_INFO[j].set_id		= 0;
		g_TMB_INFO[j].mask			= 0;
		g_TMB_INFO[j].enable		= 0;
		g_TMB_INFO[j].len			= 0;
		for( k = 0; k < 8; k++ )
		{
			g_RMB_INFO[j].data[k]	= 0;
		}
	}

	/* Rg[~Ԃŏ */
	CANC_WR_MODE_REG(CANC_MODE_STOP);

	/* ݋ */
//	CANC_WR_IRQ_EN_REG(IRQ_SET_ENABLE);
	CANC_WR_IRQ_EN_REG(0x03);

	/* ANZv^XtB^̐ݒ */
	/* Ŝ̃ANZv^XR[hWX^(Sċ)̐ݒ */
	CANC_WR_ACCEPTANCE_CODE_REG(0xFFFFFFFFU);

	/* Ŝ̃ANZv^X}XNWX^(Sċ)̐ݒ */
	CANC_WR_ACCEPTANCE_MASK_REG(0xFFFFFFFFU);

	/* WX^̏ */
	/* M̃bZ[WLZ */
	CANC_WR_TXABORT_REG(TXABORT_CLEAR);

	/* G[JE^WX^̒l(MAMƂɒl0ŖꍇAMG[JE^̕ύX͕s) */
	CANC_WR_ERROR_CNT_REG(ERROR_CNT_CLEAR);

	/* ZtMvWX^𑗎Mv𖳂ɂ */
	CANC_WR_RXSELFREQ_REG(RXSELFREQ_CLEAR);

	/* MEFCgWX^EFCgItɂ */
	CANC_WR_RXWAIT_REG(RXWAIT_OFF);

	/* MWX^𑗐Mɂ */
	CANC_WR_TXCMP_REG(TXCMP_CLEAR);

	/* MLZWX^𑗐MLZɂ */
	CANC_WR_TXABORTCMP_REG(TXABORTCMP_CLEAR);

	/* MWX^Mf[^ɂ */
	CANC_WR_RXCMP_REG(RXCMP_CLEAR);

	/* MI[o[CgWX^㏑ɂ */
	CANC_RD_RXOVERWRITE_REG();

	/* M݋WX^荞݋ɂ */
	CANC_WR_IRQ_RXEN_REG(IRQ_RXEN_PERMIT);

	/* 荞ݗvWX^荞ݖɂ */
	/* read邱ƂŁAll(ݖ)ɃZbg */
	CANC_RD_IRQ_REG();

	/* {[[g̐ݒ */
	CANC_WR_CLKDIV_BUSTIM_REG(BAUDRATE_500);

	return( STATUS_OK );
}

/** [{bNXݒ
 * @param *mb_num:MBԍ
 * @param *direction:M DIR_RECV or DIR_SND
 * @param ide:ID
 * @param *id:ID
 * @param *mask:}XN
 * @param remote:f[^
 * @retval STATUS_OK
 * @retval STATUS_ERROR
 */
STATUS
NcanSetMailBoxInfo(uint8 no, uint8 mb_num, uint8 direction,
				   uint8 ide, uint32 id, uint8 mask, uint32 remote){
	uint32	can_id_reg;
	if (direction == DIR_RECV) {
		/* Ώۂݒ肷 */
		CANC_WR_MBOXWIN_REG(mb_num);

		/* eMbZ[W{bNX̃ANZv^XR[hWX^̐ݒ */
		can_id_reg = ((uint32) id) << ACCEPTANCE_OFFSET;
		CANC_WR_RXMBOX_ACCEPTANCE_CODE_REG(can_id_reg);

		/* eMbZ[W{bNX̃ANZv^X}XNWX^̐ݒ */
		CANC_WR_RXMBOX_ACCEPTANCE_MASK_REG(ACCEPTANCE_MASK);
	}

	if (direction == DIR_SEND) {
		g_TMB_INFO[mb_num].set_id = id;
	}

	return( STATUS_OK );
}

void
NcanEnable(uint8 no){
	CANC_WR_MODE_REG(CANC_MODE_START);
}

void
NcanDisable(uint8 no){
	CANC_WR_MODE_REG(CANC_MODE_STOP);
}

#include "t_syslog.h"
#include "t_stdlib.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"

STATUS
NcanSetTxData(uint8 no, uint8 mb_num, uint8 id, uint8 *p_data, uint8 len){
	uint8			i, j;
	uint32			temp_data1 = 0;         /* f[^(1`4byte)i[p */
	uint32			temp_data2 = 0;         /* f[^(5`8byte)i[p */
	uint32			request_bit;

	/* bZ[W̃f[^5byteȏȂA5byteڈȍ~Ɏ擾 */
	if (len > BYTE_LENGTH) {
		/* 5`8bytẽf[^Rs[ */
		for (i = 0U; i < (len - BYTE_LENGTH); i++) {
			if (i > 0U) {
				temp_data2 = temp_data2 << 8U;
			}
			temp_data2 = (temp_data2 | p_data[len - (1U + i)]);
		}
	}
	else {
		i = 0U;
	}

	/* bZ[W̃f[^1byteȏȂA1byteڈȍ~擾 */
	if (len > 0) {
		/* 1`4bytẽf[^Rs[ */
		for (j = i; j < len; j++) {
			if (j > i) {
				temp_data1 = temp_data1 << 8U;
			}
			temp_data1 = (temp_data1 | p_data[len - (1U + j)]);
		}
	}

	/* CAN-ID̊i[ */
	CANC_WR_TXMBOX_DATA0_REG((id << EXTEND_CAN_ID_LENGTH), mb_num);

	/* f[^̊i[ */
	CANC_WR_TXMBOX_DATA1_REG(len, mb_num);

	if (len > 0) {
		/* f[^(1`4)̊i[ */
		CANC_WR_TXMBOX_DATA2_REG(temp_data1, mb_num);
	}
	/* f[^5byteȏȂi[ */
	if (len > BYTE_LENGTH) {
		/* f[^(5`8)̊i[ */
		CANC_WR_TXMBOX_DATA3_REG(temp_data2, mb_num);
	}

	SuspendAllInterrupts();

	request_bit = 1U << mb_num;
	CANC_WR_TXREQ_REG(request_bit);

	ResumeAllInterrupts();

	set_led7(TRUE);
	return( STATUS_OK );
}

/*
 * f[^MĂȂꍇp_len0Ԃ
 */
STATUS
NcanGetRxData(uint8 no, uint8 mb_num, uint8 *p_data, uint8 *p_len){
	uint16 j, len;
	TYPE_RMB_INFO *rmb_info;

	rmb_info = &g_RMB_INFO[mb_num];

	if( mb_num >= DEF_RMB_MAX )
	{
		return( STATUS_ERROR );
	}

	if( p_data == NULL )
	{
		return( STATUS_ERROR );
	}
	if( p_len == NULL )
	{
		return( STATUS_ERROR );
	}

	len = (*rmb_info).len;
	(*rmb_info).len = 0;

	for( j = 0;j < len; j++ )
	{
		p_data[j] = (*rmb_info).data[j];
	}

	*p_len = len;

	if(len != 0){
		set_led0(FALSE);
	}

	return( STATUS_OK );
}

static int cnt;

ISR(Ncan_ISR)
{
	uint32				irq_reg;
	uint32				cmp_reg;
	uint32				clear_bit;
	uint32				temp_data;
	uint32				i;
	uint32				j;
	uint32				wait_reg;
	uint8				can_dlc;

	irq_reg = CANC_RD_IRQ_REG();

	/* M */
	if ((irq_reg & RECEIVE_IRQ) != 0U) {
		set_led0(TRUE);
		clear_bit = 1U;
		cmp_reg = CANC_RD_RXCMP_REG();
		if (cmp_reg != 0U) {
			for (i = 0U; i < DEF_RMB_MAX; i++) {
				if ((cmp_reg & 1U) != 0U) {
					/* ΏێMEFCgWX^̊YrbgEFCgONɂ */
					wait_reg = CANC_RD_RXWAIT_REG();
					wait_reg |= clear_bit;
					CANC_WR_RXWAIT_REG(wait_reg);

					/* CAN-IDo */
					g_RMB_INFO[i].recv_id = ((CANC_RD_RXMBOX_DATA0_REG(i) & MASK_CAN_ID_MASK) >> EXTEND_CAN_ID_LENGTH);

					/* DLC̎o */
					g_RMB_INFO[i].len = (uint8) (CANC_RD_RXMBOX_DATA1_REG(i) & MASK_4BIT);
					can_dlc = g_RMB_INFO[i].len;

					if (can_dlc > BYTE_LENGTH) {
						/* 5byteȏ̏ꍇA5byteڈȍ~̃WX^ǂݍ */
						/* SDU(1`4byte)̎o */
						temp_data = CANC_RD_RXMBOX_DATA2_REG(i);
						for (j = 0U; j < BYTE_LENGTH; j++) {
							g_RMB_INFO[i].data[j] = (uint8) (temp_data & MASK_8BIT);
							temp_data >>= 8U;
						}
						/* SDU(5`8byte)̎o */
						temp_data = CANC_RD_RXMBOX_DATA3_REG(i);
						for (j = BYTE_LENGTH; j < can_dlc; j++) {
							g_RMB_INFO[i].data[j] = (uint8) (temp_data & MASK_8BIT);
							temp_data >>= 8U;
						}
					}
					else {
						/* 4byteȉ̏ꍇA5byteڈȍ~̃WX^͓ǂݍ܂Ȃ */
						/* SDU(1`4byte)̎o */
						temp_data = CANC_RD_RXMBOX_DATA2_REG(i);
						for (j = 0U; j < can_dlc; j++) {
							g_RMB_INFO[i].data[j] = (uint8) (temp_data & MASK_8BIT);
							temp_data >>= 8U;
						}
					}
					CANC_WR_RXCMP_REG(clear_bit);
					/* ΏێMEFCgWX^̊YrbgEFCgOFFɂ */
					wait_reg = wait_reg ^ clear_bit;
					CANC_WR_RXWAIT_REG(wait_reg);
				}
				cmp_reg >>= 1U;
				clear_bit <<= 1U;
			}
		}
	}

	/* M */
	if ((irq_reg & TRANSMIT_IRQ) != 0U) {
		set_led7(FALSE);
		clear_bit = 1U;
		cmp_reg = CANC_RD_TXCMP_REG();
		if (cmp_reg != 0U) {
			for (i = 0U; i < DEF_TMB_MAX; i++) {
				if ((cmp_reg & 1U) != 0U) {
					CANC_WR_TXCMP_REG(clear_bit);
				}
				cmp_reg >>= 1U;
				clear_bit <<= 1U;
			}
		}
	}

	if ((irq_reg & 0x80) == 0x80U) {
		syslog(LOG_NOTICE, "NCAN : buserror! %d", cnt++);
	}
}
